// Datei: CHECKDISP.C
//
//
// Check auf obere Grenzfrequenz ndern !!!
//
//

// 30MHz-PLL_Rechteckgenerator mit PIC16C84
//
// Prft eingegebene Werte auf Gltigkeit
//
// Holger Klabunde
// 30.04.2001
// Compiler CC5x

#include "prozess.h"      /* Der verwendete Prozessor */

#include "pllser84.h"
#include "protos.h"

//****************************************************
// Bearbeitet die Frequenzeinstellung des Generators
// Prft die eingegebenen Displaywerte auf Gltigkeit 
// und korrigiert gegebenenfalls 
//****************************************************
void CheckDisplay()
{
// Cursor up 
 if(key==UP)
  {
   if(display[stelle]<9) display[stelle]=display[stelle]+1;
// berlauf der Dezimalstelle !! oben eins draufgeben
   else
    {

     if(stelle>1) // 1.Stelle max.=1
      {
       j=stelle-1; result=1;

       do // erste Stelle links suchen die kleiner 9 ist
        {
	   if(display[j]<9) result=0; 	// gefunden
         if(display[j]==9) j--;  	// nicht gefunden
        } while ((j!=1)&&(result!=0));
      }

     display[j]=display[j]+1;

     do // alle 9en rechts auf 0
      {
	 j++;
       display[j]=0; 
      } while((stelle-j)!=0);    

   }
// Ende berlauf der Dezimalstelle

  } // if key==UP

 if(key==DOWN)
  {
// Display>0 kein bertrag ntig evtl. Abfrage Display = 0 oder <1kHz
   if(display[stelle]>0) display[stelle]=display[stelle]-1;
// Unterlauf der Dezimalstelle oben eins abziehen
   else
    {
     if(stelle>1)
      {
/* Jetzt gibt es zwei Mglichkeiten
  1. Links von dieser Stelle stehen nur Nullen result=0
     Dann keine Aktion
  2. Links von dieser Stelle existiert eine Stelle>0 result=1
     Hier gibt es wieder zwei Mglichkeiten
     A. Zwischen den Stellen existieren keine Nullen result=0
        Die Stellen liegen direkt nebeneinander!
        Dann einfach eins abziehen und display[stelle]:=9     
     B. Zwischen den Stellen existieren Nullen result=1
        Von der hchsten Stelle eins abziehen.
        Alle anderen Stellen dazwischen werden 9
*/    

// Links Stellen ungleich Null suchen
       result=0; j=stelle;
       do
        {
	   j--; // eine Stelle nach links
         if(display[j]>0) result=1; // gefunden
        } while((j!=1)&&(result!=1));

// Eine Stelle>0 gefunden
       if(result!=0)
        {
         if((stelle-j)==1) // Stellen direkt nebeneinander
          {
	     display[stelle]=9;
           display[j]=display[j]-1;
          }
         if((stelle-j)>1) // mindestens eine Null dazwischen
          {
		display[j]=display[j]-1; // Hchste Stelle - 1
            for(i=j+1; i<(stelle+1); i++) display[i]=9; // dazwischen alles 9
          }
        }

      } // if stelle>1
    }  // else von if display[stelle]>0
  }   // if key=DOWN

 ShowDisplay(); 
}
