//Datei: PROTOS.H
// 30MHz-PLL_Rechteckgenerator mit PIC16C|F84
//
// Nur Prototypen
//
// Copyright 1998 by Holger Klabunde
// 30.04.2001
// Compiler CC5x

#ifndef PROTOS_H
#define PROTOS_H
extern void InitPIC();
extern void InitLCD();
extern void Delay1ms(unsigned char);
extern void ShowHex(unsigned char by);

extern void LCDWriteByte(unsigned char);
extern void LCDWrite(const char *);
extern void LCDCls();
extern void LCDPos(unsigned char, unsigned char);

extern void ShowDisplay();
extern void CheckDisplay();

extern void SetPLL();
extern void WritePLLByte(unsigned char);

extern char Read_EEProm(unsigned char addr);
extern void Write_EEProm(unsigned char addr, unsigned char data);

extern unsigned char stelle; 	//Position auf der LCD-Anzeige
extern unsigned char key; 	//Tastatur lesen
extern unsigned char i,j;	//Alle mglichen Schleifen
extern unsigned char result;	//Zwischenergebnisse
extern unsigned char tastbuf; //Tastaturpuffer fr lesen im INT
extern unsigned char boing;    //Warten auf INT

extern unsigned char display[7];	//BCD Werte des Generators

#endif
